package estructuras.arboles;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Comparator;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;
import java.util.SortedMap;

/**
 * Arbol binario ordenado
 * @author Alvaro
 *
 * @param <K>
 * @param <V>
 */
public class ArbolBO<K extends Comparable<K>, V> implements Serializable, SortedMap<K, V>
{

	/***
	 * Nodo raz del arbol 
	 */
	private NodoABO<K, V> raiz;
	
	/**
	 * Construye un nuevo rbol sin elementos
	 */
	public ArbolBO() 
	{
		raiz = null;
	}
	
	/**
	 * Construye un nuevo rbol con el elemento que llega por parmetro
	 * @param nRaiz la nueva raz del rbol. nRaiz != null
	 */
	public ArbolBO(NodoABO<K, V>  nRaiz) 
	{
		raiz = nRaiz;
	}
	
	/**
	 * Elimina todos los elementos del rbol
	 */
	public void clear() 
	{
		//TODO complete segn la documentacin

	}


	/**
	 * Indica si en el rbol algn nodo tiene el identificador por parmetro
	 * @param id identificador que se desea buscar
	 * @return true en caso de que el rbol contenga un el nodo con id dado por parmetro, false en caso contrario
	 */
	public boolean containsKey(Object id) 
	{
		K buscado = (K)id;
		//TODO complete segn la documentacin
	}


	/**
	 * Indica si algn nodo del rbol tiene el elemento por parmetro
	 * @param elem el elemento que se desea buscador
	 * @return true en caso de que el rbol contenga un nodo con el elemento dado por parmetro
	 */
	public boolean containsValue(Object elem) 
	{
		V buscado = (V)elem;
		//TODO complete segn la documentacin
	}

	/**
	 * Devuelve el elemento con el identificador dado por parmetro
	 * @param id el identificador del elemento que se desea buscar
	 * @return el elemento con el identificador dado por parmetro o null en caso que no se encuentre en el rbol
	 */
	public V get(Object id) 
	{
		K buscado = (K)id;
		//TODO complete segn la documentacin
	}

	/**
	 * Indica si el rbol est vaco
	 * @return true en caso que el rbol est vaco o false en caso contrario
	 */
	public boolean isEmpty() 
	{
		//TODO complete segn la documentacin
	}


	/**
	 * Agrega un nodo al rbol
	 * @param id el identificador del nodo
	 * @param elem el elemento del nodo
	 * @return null
	 * @throws NullPointerException en caso que el id o elemento sen nulos
	 * @throws IllegalArgumentException en caso que ya exista un nodo con el id dado
	 */
	public V put(K id, V elem)  throws NullPointerException, IllegalArgumentException
	{
		//TODO complete segn la documentacin
		return null;	
	}


	/**
	 * Agrega todos los elementos del mapa que llega por parmetro al rbol
	 */
	public void putAll(Map<? extends K, ? extends V> map) 
	{
		Iterator<? extends K> llaves = map.keySet().iterator();
		while(llaves.hasNext())
		{
			K llave = llaves.next();
			put(llave, map.get(llave));
		}
		
	}
	
	/**
	 * Elimina un nodo del rbol
	 * @param id el identificador del nodo
	 * @return el elemento almacenado en el nodo eliminado
	 */
	public V remove(Object id) 
	{
		K buscado = (K)id;
		V eliminado = get(id);
		if( eliminado != null )
		{
			raiz = raiz.remove(buscado);
		}
		return eliminado;
		
	}

	/**
	 * Devuelve la cantidad de nodos en el rbol
	 * @return nodos en el rbol
	 */
	public int size() 
	{
		//TODO complete segn la documentacin
	}

	/**
	 * Duevuelve el comparador de los nodos en el rbol
	 * @return null para indicar que se comparn por el comparador natural de K
	 */
	public Comparator<? super K> comparator() 
	{
		return null;
	}

	/**
	 * Devuelve un conjunto con los nodos del rbol
	 * @return nodos del rbol o un conjunto vaco en caso que el rbol lo est
	 */
	public Set<java.util.Map.Entry<K, V>> entrySet() 
	{
		Set<java.util.Map.Entry<K, V>> s = new HashSet<java.util.Map.Entry<K, V>>();
		if(raiz!=null)
		{
			raiz.entrySet(s);
		}
		
		return s;
	}

	/**
	 * Devuelve la llave menor dentro del rbol
	 * @return menor llave del rbol o null en caso que el rbol est vaco
	 */
	public K firstKey() 
	{
		//TODO complete segn la documentacin
	}

	/**
	 * Devuelve un rbol binario ordenado con los nodos del rbol que tengan un id menor al limite dado
	 * @return rbol Binario Ordenado con los elementos de llave menor a la dada por parmetro o un rbol vacio si ningpun elemento tiene una llave menor
	 */
	public SortedMap<K, V> headMap(K limite) 
	{
		//TODO complete segn la documentacin
	}

	/**
	 * Devuelve un conjunto con todos los id del rbol
	 * @return conjunto con los identificadores de todos los nodos del rbol o un conjunto vaco si el rbol lo est
	 */
	public Set<K> keySet() 
	{
		Set<K> s = new HashSet<K>();
		if(raiz!=null)
		{
			raiz.keyset(s);
		}
		
		return s;
	}


	/**
	 * Devuelve el maypr identificador dentro del rbol
	 * @return mayor id dentro del rbol o null si este est vaco
	 */
	public K lastKey() 
	{
		//TODO complete segn la documentacin
	}

	/**
	 * Devuelve un rbol binario ordenado con los nodos del rbol cuyos id estn entre los limite dados por parmetro 
	 * @param limiteInf lmite inferior para la busqueda, se excluye de la busqueda
	 * @param limiteSup lmite superior para la busqueda, se incluye en la busqueda
	 * @return rbol Binario Ordenado con los nodos de id entre los lmites dados o un rbol vacio si ningn nodo cumple la condicin
	 */
	public SortedMap<K, V> subMap(K limiteInf, K limiteSup) 
	{
		//TODO complete segn la documentacin

	}

	/**
	 * Devuelve un rbol binario ordenado con los nodos del rbol que tengan un id mayor o igual al lmite dado
	 * @return rbol Binario Ordenado con los elementos de llave mayor o igual a la dada por parmetro o un rbol vacio si ningpun elemento tiene una llave menor
	 */
	public SortedMap<K, V> tailMap(K limite) {
		//TODO complete segn la documentacin

	}

	/**
	 * Devuelve la coleccin de elementos del rbol en inorden
	 * @return coleccin de elementos almacenados en el rbol o coleccin vaca si el rbol lo est
	 */
	public Collection<V> values() {
		//TODO complete segn la documentacin
	
	}

}
