package estructuras.arboles;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;
import java.util.SortedMap;

/**
 * rbol N-ario
 * @author Alvaro
 *
 * @param <K>
 * @param <V>
 */
public class ArbolN <K extends Comparable<K>, V> implements Serializable, Map<K, V> {

	/**
	 * Nodo raz del rbol n-ario
	 */
	private NodoAN<K, V> raiz;
	
	/**
	 * Construye un nuevo rbol n-ario sin elementos
	 */
	public ArbolN() 
	{
		raiz = null;
	}
	/**
	 * Construye un rbol con la raz que llega por parmetro
	 * @param nRaiz la nueva raz del rbol
	 */
	public ArbolN(NodoAN<K, V>  nRaiz) 
	{
		raiz = nRaiz;
	}
	
	/**
	 * Elimina todos los elementos del rbol
	 */
	public void clear() 
	{
		//TODO complete segn la documentacin
	}

	/**
	 * Indica si en el rbol algn nodo tiene el identificador por parmetro
	 * @param id identificador que se desea buscar
	 * @return true en caso de que el rbol contenga un el nodo con id dado por parmetro, false en caso contrario
	 */
	public boolean containsKey(Object id) 
	{
		K buscado = (K)id;
		//TODO complete segn la documentacin
	}

	/**
	 * Indica si algn nodo del rbol tiene el elemento por parmetro
	 * @param elem el elemento que se desea buscador
	 * @return true en caso de que el rbol contenga un nodo con el elemento dado por parmetro
	 */
	public boolean containsValue(Object elem) 
	{
		V buscado = (V)elem;
		//TODO complete segn la documentacin
	}


	/**
	 * Devuelve el elemento con el identificador dado por parmetro
	 * @param id el identificador del elemento que se desea buscar
	 * @return el elemento con el identificador dado por parmetro o null en caso que no se encuentre en el rbol
	 */
	public V get(Object id) 
	{
		K buscado = (K)id;
		//TODO complete segn la documentacin
	}
	
	/**
	 * Deuvelve un nodo del rbol dado su identificador
	 * @param id el identificador del nodo
	 * @return el nodo o null en caso de que no exista
	 */
	public NodoAN<K,V> getNodo(Object id) 
	{
		K buscado = (K)id;
		//TODO complete segn la documentacin
	}


	/**
	 * Indica si el rbol est vaco
	 * @return true en caso que el rbol est vaco o false en caso contrario
	 */
	public boolean isEmpty() 
	{
		//TODO complete segn la documentacin
	}

	/**
	 * Devuelve un conjunto con los nodos del rbol
	 * @return nodos del rbol o un conjunto vaco en caso que el rbol lo est
	 */
	public Set<java.util.Map.Entry<K, V>> entrySet() 
	{
		Set<java.util.Map.Entry<K, V>> s = new HashSet<java.util.Map.Entry<K, V>>();
		if(raiz!=null)
		{
			raiz.entrySet(s);
		}
		
		return s;
	}

	/**
	 * Devuelve un conjunto con todos los id del rbol
	 * @return conjunto con los identificadores de todos los nodos del rbol o un conjunto vaco si el rbol lo est
	 */
	public Set<K> keySet() 
	{
		Set<K> s = new HashSet<K>();
		if(raiz!=null)
		{
			raiz.keyset(s);
		}
		
		return s;
	}

	/**
	 * Agrega un nodo al rbol dada su informacin
	 * @param idPadre identificador del padre del nodo si es null el nuevo nodo se agrega como raz
	 * @param id el identificador del nuevo nodo
	 * @param elem el elemento del nuevo nodo
	 * @return el elemento del nodo agregado
	 * @throws NullPointerException Se lanza en caso que el id o elemento sen nulos
	 * @throws IllegalArgumentException Se lanza en caso que ya exista un nodo con el id dado o que no exista el padre en el rbol
	 */
	public V put(K idPadre, K id, V elem) throws NullPointerException, IllegalArgumentException
	{
		//TODO complete segn la documentacin
		
	}
	
	public V put(K key, V value) {
		// TODO No se implementa
		return null;
	}


	public void putAll(Map<? extends K, ? extends V> m) {
		// TODO No se implementa
	}

	/**
	 * Elimina un nodo del rbol
	 * @param id el identificador del nodo
	 * @return el elemento almacenado en el nodo eliminado
	 */
	public V remove(Object id) {
		K buscado = (K)id;
		V elem = null;
		if(raiz != null)
		{
			if( raiz.getKey().equals(buscado))
			{
				elem = raiz.getValue();
				raiz = null;
			}
			else
			{
				elem = raiz.remove(buscado);
				
			}
		}
		return elem;
	}

	/**
	 * Devuelve la cantidad de nodos en el rbol
	 * @return nodos en el rbol
	 */
	public int size() 
	{
		//TODO complete segn la documentacin
		
	}

	/**
	 * Devuelve la coleccin de elementos del rbol en preorden
	 * @return coleccin de elementos almacenados en el rbol o coleccin vaca si el rbol lo est
	 */
	public Collection<V> values() {
		//TODO complete segn la documentacin
		
	}
	
	/**
	 * Devuelve el nodo raz del rbol
	 * @return raiz
	 */
	public NodoAN<K,V> darRaiz()
	{
		return raiz;
	}
	
	/**
	 * Devuelve la coleccin de elementos del rbol en postorden
	 * @return coleccin de elementos almacenados en el rbol o coleccin vaca si el rbol lo est
	 */
	public Collection<V> valuesPos() {
		//TODO complete segn la documentacin
		
	}
	
	/**
	 * Devuelve la coleccin de elementos del rbol por nivel
	 * @param level el nivel del que se desean los elementos
	 * @return coleccin de elementos almacenados en el rbol o coleccin vaca si el rbol lo est
	 */
	public Collection<V> valuesLevel(int level) {
		//TODO complete segn la documentacin
		
	}
}
